<template>
  <div class="app-container">
    <el-form
      :model="queryParams"
      ref="queryForm"
      :inline="true"
      v-show="showSearch"
      label-width="68px"
    >
      <el-form-item label="年份" prop="year">
        <el-select
          v-model="queryParams.year"
          placeholder="请选择年份"
          clearable
        >
          <el-option
            v-for="year in yearList"
            :key="year"
            :label="year"
            :value="year"
          />
        </el-select>
      </el-form-item>
      <!-- <el-form-item label="月份" prop="month">
        <el-select
          v-model="queryParams.month"
          placeholder="请选择月份"
          clearable
        >
          <el-option label="01" value="01"></el-option>
          <el-option label="02" value="02"></el-option>
          <el-option label="03" value="03"></el-option>
          <el-option label="04" value="04"></el-option>
          <el-option label="05" value="05"></el-option>
          <el-option label="06" value="06"></el-option>
          <el-option label="07" value="07"></el-option>
          <el-option label="08" value="08"></el-option>
          <el-option label="09" value="09"></el-option>
          <el-option label="10" value="10"></el-option>
          <el-option label="11" value="11"></el-option>
          <el-option label="12" value="12"></el-option>
        </el-select>
      </el-form-item> -->
      <el-form-item label="州市" prop="cityCode">
        <el-select
          v-model="queryParams.cityCode"
          placeholder="请选择州市"
          clearable
        >
          <el-option
            v-for="region in regionOptions"
            :key="region.cityShortName"
            :label="region.cityShortName"
            :value="region.code"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="高价值类型" label-width="100px"  >
        <el-checkbox-group v-model="checkedHighValues" >
          <el-checkbox v-for="t in highValueList" :label="t.id" :key="t.id">{{t.name}}</el-checkbox>
        </el-checkbox-group>
      </el-form-item>
      <el-form-item label="是否添加人口信息" label-width="150px" prop="highValue">
        <el-select
          v-model="queryParams.highValue"
          placeholder="请选择是否添加人口信息"
          clearable
          @change="selectb"
        >
          <el-option
            v-for="item in getApplicantTypesb"
            :key="item.id"
            :label="item.name"
            :value="item.id"
          >
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item style="margin-left: 25px;">
        <el-button
          type="primary"
          icon="el-icon-search"
          size="mini"
          @click="handleQuery"
          >搜索</el-button
        >
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery"
          >重置</el-button
        >
        <el-button type="primary"  size="mini" @click="handleExport"
          >导出列表</el-button
        >
      </el-form-item>
    </el-form>

    <div id="scrollTable">
      <el-table
        v-loading="loading"
        :data="rzgHighValueIewStatisticsInfoList"
        :max-height="maxHeight"
        :header-cell-style="{ background: '#2a8eed', color: '#fafcfe' }"
      >
        <el-table-column label="地区" align="center" width="100" fixed="left">
          <template slot-scope="scope">
            <span>{{ scope.row["areaName"] }}</span>
          </template>
        </el-table-column>

        <el-table-column label="历年高价值发明专利数量" align="center">
          <el-table-column
            :label="y"
            align="center"
            v-for="(y, yi) in hasYearList"
            :key="yi"
          >
            <el-table-column label="合计" align="center">
              <template slot-scope="scope">
                <span>{{ scope.row["yearData"][y].totalCnt }}</span>
              </template>
            </el-table-column>

            <el-table-column label="战略性新兴产业" align="center"  v-if="showHighValueTypeObj.hvSeisPress">
              <template slot-scope="scope">
                <span>{{ scope.row["yearData"][y].seis }}</span>
              </template>
            </el-table-column>

            <el-table-column label="维持年限超10年" align="center" v-if="showHighValueTypeObj.hvKeep10Press">
              <template slot-scope="scope">
                <span>{{ scope.row["yearData"][y].keep10Years }}</span>
              </template>
            </el-table-column>
            <el-table-column label="在海外有同族专利权" align="center" v-if="showHighValueTypeObj.hvHaveOverseasPress">
              <template slot-scope="scope">
                <span>{{ scope.row["yearData"][y].haveOverseas }}</span>
              </template>
            </el-table-column>
            <el-table-column label="获得较高质押融资金额" align="center" v-if="showHighValueTypeObj.hvHighPledgePress">
              <template slot-scope="scope">
                <span>{{ scope.row["yearData"][y].highPledge }}</span>
              </template>
            </el-table-column>
            <el-table-column label="获得国家科技奖或中国专利奖" align="center" v-if="showHighValueTypeObj.hvTechnologyAwardPress">
              <template slot-scope="scope">
                <span>{{ scope.row["yearData"][y].technologyAward }}</span>
              </template>
            </el-table-column>
          </el-table-column>
        </el-table-column>
      </el-table>
    </div>



    <div v-if="open1" style="margin-top: 50px;">
      <el-table
        v-loading="loading"
        :data="Population"
        :max-height="maxHeight"
        :header-cell-style="{ background: '#2a8eed', color: '#fafcfe' }"
      >
        <el-table-column label="地区" align="center" width="100" fixed="left">
          <template slot-scope="scope">
            <span>{{ scope.row["cityName"] }}</span>
          </template>
        </el-table-column>

        <el-table-column label="人口信息表(万人)" align="center" >

          <el-table-column
            :label="String(y)"
            align="center"
            v-for="(y, i) in popuYearList"
            :key="i"
          >
          <template slot-scope="scope">
                <span>{{ scope.row["popuMap"][String(y)] }}</span>
              </template>
        </el-table-column>


        </el-table-column>
      </el-table>
    </div>
  </div>
</template>

<script>
import {
  listRzlViewStatisticsInfo,
  getRzlViewStatisticsInfo,
  delRzlViewStatisticsInfo,
  addRzlViewStatisticsInfo,
  updateRzlViewStatisticsInfo,
  getYearList,
} from "@/api/report/rzlViewStatisticsInfo";
import {
  listPopulation,
  listRzgHighValueIewStatisticsInfo,
  getRzgHighValueIewStatisticsInfo,
  delRzgHighValueIewStatisticsInfo,
  addRzgHighValueIewStatisticsInfo,
  updateRzgHighValueIewStatisticsInfo,
} from "@/api/highval/rzgHighValueIewStatisticsInfo";
import {  getHighValues ,getApplicantTypesb} from "@/api/staticdata.js";
import {
  listUrPatentValid,
  getHeaderList,
  getRegionList,
} from "@/api/system/urPatentValid";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";
export default {
  name: "RzgHighValueIewStatisticsInfo",
  data() {
    return {
      hearderTitle: "统计时期2023-1",
      headerList: [],
      // 查询年份数据
      yearList: [],
      hasYearList: [],
      regionOptions: [],
      getApplicantTypesb: [],
      checkedHighValues: [],
      showHighValueTypeObj:{
        hvSeisPress:true,hvKeep10Press:true,hvHaveOverseasPress:true,hvHighPledgePress:true,hvTechnologyAwardPress:true
      },

      popuYearList:[],
      maxHeight: 0,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 高价值专利-概况统计表格数据
      rzgHighValueIewStatisticsInfoList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      open1:false,
      // 查询参数
      queryParams: {
        year: "2022",
        pageNum: 1,
        pageSize: 10,
        cityCode: null,
        cityName: null,
        month: "12",
        patentType: null,
        higherSchool: null,
        researchInstitute: null,
        enterprise: null,
        institutions: null,
        individual: null,
        status: null,
        highValue:'1'
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {},
      Population:[]
    };
  },
  created() {
    this.getYear();
    this.getRegion();
    //this.getHeader();

    this.checkedHighValues=[];
    this.highValueList = getHighValues();
    for(let i=0;i<this.highValueList.length;i++){
      this.checkedHighValues.push(this.highValueList[i].id);
    }
    this.getApplicantTypesb = getApplicantTypesb();
    this.$nextTick(() => {
      this.maxHeight = window.innerHeight - 200; //300是页面中除了表格外其他组件的高度
    });
    this.showHighValueTitle();

    this.getList();
  },
  methods: {
    selectb(e){
      if(e == 1){
        this.open1 = true
      }else{
        this.open1 = false
      }
    },
    getHighValues3() {
      let types = [{
        id: '1',
        name: '战略性新兴产业',code:'hvSeisPress'
      },{id: '2',
        name: '维持年限超10年',code:'hvKeep10Press'
      },{
        id: '3',
        name: '在海外有同族专利权',code:'hvHaveOverseasPress'
      },{
        id: '4',
        name: '获得较高质押融资金额',code:'hvHighPledgePress'
      },{
        id: '5',
        name: '获得国家科技奖或中国专利奖',code:'hvTechnologyAwardPress'
      }];
      return types;
    },

    /** 获取省市列表 */
    getRegion() {
      let params = {};
      getRegionList(params).then((response) => {
        this.regionOptions = response.data;
      });
    },
    getCheckedHighValueIdStr(){
      let ids='';
      //console.log('lenss:'+this.checkedHighValues.length);
      for(let i=0;i<this.checkedHighValues.length;i++){
        if(i>0){
          ids=ids+',';
        }
        ids=ids+this.checkedHighValues[i];
      }
      //console.log('idsgetCheckedHighValueIdStr:'+ids);
      return ids;
    },
    allHighValueSelect(){
      this.highValueList=this.getHighValues3();
      this.checkedHighValues=[];
      for(let i=0;i<this.highValueList.length;i++){
        this.checkedHighValues.push(this.highValueList[i].id);
      }

    },
    showHighValueTitle(){
      //如果一个都被选就自动全选
      if(this.checkedHighValues.length==0){
        this.allHighValueSelect();
      }
      let allTypes=this.getHighValues3();
      for(let i=0;i<allTypes.length;i++){
        let id=allTypes[i].id;
        if(this.checkedHighValues.indexOf(id)>=0){
          //console.log('准备设置为 true:'+allTypes[i].code)
          this.showHighValueTypeObj[allTypes[i].code]=true;
        }else{
          //console.log('准备设置为 false:'+allTypes[i].code)
          this.showHighValueTypeObj[allTypes[i].code]=false;
        }
      }
    },
    handerMethod({ row, column, rowIndex, columnIndex }) {
      // if (rowIndex === 0) {
      //     if (column.label == '地区' || column.label == '专利类型') {
      //         this.$nextTick(() => {
      //             var _c = document.getElementsByClassName(column.id);
      //             document.getElementsByClassName(column.id)[0].setAttribute('rowSpan', 2);
      //         });
      //         return column;
      //     }
      // } else if (rowIndex === 1) {
      //     if (column.label == '地区' || column.label == '专利类型') {
      //         return { display: 'none' };
      //     }
      // }
      // if (column[0].level == 1) {
      //     column[0].rowSpan = 2
      //     column[1].rowSpan = 0
      //     if (rowIndex === 1) {
      //         return { display: 'none' }
      //     }
      // }
    },

    /** 获取动态表头 */
    getHeader() {
      this.queryParams.startDate = this.queryParams.year;
      getHeaderList(this.queryParams).then((response) => {
        this.headerList = response.data;
      });
    },
    /** 获取查询年份列表 */
    getYear() {
      getYearList().then((response) => {
        this.yearList = response.data;
      });
    },

    /** 查询专利有效-概况统计列表 */
    getList() {
      let qp=this.queryParams;
      this.loading = true;
      this.queryParams.highValueTypes=this.getCheckedHighValueIdStr();
      listRzgHighValueIewStatisticsInfo(this.queryParams).then((response) => {
        this.rzgHighValueIewStatisticsInfoList = response.data.dataList;
        this.hasYearList = response.data.yearList;
        this.total = 0;
        this.loading = false;
        listPopulation(qp).then((response) => {
          console.log('收到人口信息列表....')
          if(response && response.data && response.data.popuList){
            this.Population = response.data.popuList;

            let minYear=response.data.minYear;
            let maxYear=response.data.maxYear;
            this.popuYearList=[];
            for(let y=minYear;y<=maxYear;y++){
              this.popuYearList.push(String(y));
            }


          }




          console.log(this.Population,'this.Population');
        });
      });
    },

    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        cityCode: null,
        cityName: null,
        year: null,
        month: null,
        patentType: null,
        higherSchool: null,
        researchInstitute: null,
        enterprise: null,
        institutions: null,
        individual: null,
        remark: null,
        delFlag: null,
        status: 0,
        createTime: null,
        createBy: null,
        updateTime: null,
        updateBy: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      if (this.queryParams.month) {
        if (this.queryParams.year) {
          //this.getHeader();
          this.queryParams.pageNum = 1;
          this.getList();
          this.showHighValueTitle();
        } else {
          this.$message("请选择年份");
        }
      } else {
        //this.getHeader();
        this.queryParams.pageNum = 1;
        this.getList();
        this.showHighValueTitle();
      }
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加专利有效-概况统计";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids;
      getRzlViewStatisticsInfo(id).then((response) => {
        this.form = response.data;
        this.open = true;
        this.title = "修改专利有效-概况统计";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.form.id != null) {
            updateRzlViewStatisticsInfo(this.form).then((response) => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addRzlViewStatisticsInfo(this.form).then((response) => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal
        .confirm('是否确认删除专利有效-概况统计编号为"' + ids + '"的数据项？')
        .then(function () {
          return delRzlViewStatisticsInfo(ids);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download(
        "highval/rzgHighValueIewStatisticsInfo/export",
        {
          ...this.queryParams,
        },
        `rzlViewStatisticsInfo_${new Date().getTime()}.xlsx`
      );
    },
  },
};
</script>


<style rel="stylesheet/scss" lang="scss" scoped>
// ----------修改elementui表格的默认样式-----------
.el-table__body-wrapper {
  &::-webkit-scrollbar {
    // 整个滚动条
    width: 0; // 纵向滚动条的宽度
    background: rgba(213, 215, 220, 0.3);
    border: none;
  }
  &::-webkit-scrollbar-track {
    // 滚动条轨道
    border: none;
  }
}

// --------------------隐藏table gutter列和内容区右侧的空白 start
.el-table th.gutter {
  display: none;
  width: 0;
}
.el-table colgroup col[name="gutter"] {
  display: none;
  width: 0;
}

.el-table__body {
  width: 100% !important;
}

// --------------------隐藏table gutter列和内容区右侧的空白 end
</style>
